/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/* map.h:  Header file for lm_map.c                                 */
/*         Contains function declarations for map estimation.       */
/*         Simple functions live in map_fncts.c, while              */
/*         Complex funcitons live in map_ops.c                      */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
#define TINY 1.0e-9

double rf (double);         /* Converts cM Haldane to recomb fracts */
double cmH (double xx);     /* Converts recomb fracts to cM Haldane */

void get_init (int, double**, double*, int);    
                            /* Samples a Beta(2,k) r.v.             */
                            /* Perturbs the map given in par.file   */

void swcpy (int*, int*, int*, int*);
                            /* Copies S.j into new_S.j              */

void decide (double*);      /* Computes and evaluates hratio        */

void pr_section(int);       /* Prints header for type of analysis   */

void  ludcmp (double **, int, int *, double *d);
void  lubksb (double **, int, int *, double *bnr);
double find_intv (double, double, int *z);
void  lr_cdllr (int, double *, double **, double **, double **, 
                int ***, int ***);
void  change_map (int, int, double **, double **);
int   comp_map (double, double **, double **);
void  sw_map (double **, double **);
void  pr_map (int, double **);
void  set_rc (int, int ***, double **);
void  reset_globs (int, int );
 /*-----------------------------------------------------------------*/

int mcemit (int, int, int, int ***, double **, double **, double **);
void obs_info (int, double **, int ***, int ***, int, double **,
               double **, double **, int, int);
void d_invert (double **, double **, int);
void sait (int, int, int ***, int, double **, double **, double **,
           double **);
double logLR (double **, double **, int, int ***, int ***, double **,
              double **, int *, int);

/*--------------------WITH0UT ERROR PARAMETERS----------------------*/
   int   Glob_Max = 100;       /* LB: numb of scans in log(L(.,.))  */
   int   Obs_Info_Avg = 10;    /* LB: numb of scans in I(.)         */
   int   Obs_Info_Spc = 10;    /* LB: numb of scans in I(.,.)       */
   int   SA = 1;               /* SA =  1 means that SA is done     */
   double Alpha = 0.90;        /* alpah = 1 --> phi_o = init_phi    */

