/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* tred1.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int tred1_ (nm, n, a, d__, e, e2)
     integer *nm, *n;
     doublereal *a, *d__, *e, *e2;
{
   /* System generated locals */
   integer a_dim1, a_offset, i__1, i__2, i__3;
   doublereal d__1;

   /* Builtin functions */
   double sqrt (), d_sign ();

   /* Local variables */
   static doublereal f, g, h__;
   static integer i__, j, k, l;
   static doublereal scale;
   static integer ii, jp1;

/* ***BEGIN PROLOGUE  TRED1 */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4C1B1 */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Reduce DOUBLE PRECISION symmetric matrix to symmetric tridiagonal */
/*            matrix using orthogonal similarity transformations. */
/* ***DESCRIPTION */

/*     This subroutine is a translation of the ALGOL procedure TRED1, */
/*     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson. */
/*     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971). */

/*     This subroutine reduces a DOUBLE PRECISION SYMMETRIC matrix */
/*     to a symmetric tridiagonal matrix using */
/*     orthogonal similarity transformations. */

/*     On Input */

/*        NM must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        N is the order of the matrix. */

/*        A contains the DOUBLE PRECISION symmetric input matrix.  Only the */
/*          lower triangle of the matrix need be supplied. */

/*     On Output */

/*        A contains information about the orthogonal trans- */
/*          formations used in the reduction in its strict lower */
/*          triangle.  The full upper triangle of A is unaltered. */

/*        D contains the diagonal elements of the tridiagonal matrix. */

/*        E contains the subdiagonal elements of the tridiagonal */
/*          matrix in its last N-1 positions.  E(1) is set to zero. */

/*        E2 contains the squares of the corresponding elements of E. */
/*          E2 may coincide with E if the squares are not needed. */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ */
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, */
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  TRED1 */

/* ***FIRST EXECUTABLE STATEMENT  TRED1 */
   /* Parameter adjustments */
   --e2;
   --e;
   --d__;
   a_dim1 = *nm;
   a_offset = a_dim1 + 1;
   a -= a_offset;

   /* Function Body */
   i__1 = *n;
   for (i__ = 1; i__ <= i__1; ++i__)
   {
/* L100: */
      d__[i__] = a[i__ + i__ * a_dim1];
   }
/*     .......... FOR I=N STEP -1 UNTIL 1 DO -- .......... */
   i__1 = *n;
   for (ii = 1; ii <= i__1; ++ii)
   {
      i__ = *n + 1 - ii;
      l = i__ - 1;
      h__ = 0.;
      scale = 0.;
      if (l < 1)
      {
         goto L130;
      }
/*     .......... SCALE ROW (ALGOL TOL THEN NOT NEEDED) .......... */
      i__2 = l;
      for (k = 1; k <= i__2; ++k)
      {
/* L120: */
         scale += (d__1 = a[i__ + k * a_dim1], abs (d__1));
      }

      if (scale != 0.)
      {
         goto L140;
      }
    L130:
      e[i__] = 0.;
      e2[i__] = 0.;
      goto L290;

    L140:
      i__2 = l;
      for (k = 1; k <= i__2; ++k)
      {
         a[i__ + k * a_dim1] /= scale;
         h__ += a[i__ + k * a_dim1] * a[i__ + k * a_dim1];
/* L150: */
      }

      e2[i__] = scale * scale * h__;
      f = a[i__ + l * a_dim1];
      d__1 = sqrt (h__);
      g = -d_sign (&d__1, &f);
      e[i__] = scale * g;
      h__ -= f * g;
      a[i__ + l * a_dim1] = f - g;
      if (l == 1)
      {
         goto L270;
      }
      f = 0.;

      i__2 = l;
      for (j = 1; j <= i__2; ++j)
      {
         g = 0.;
/*     .......... FORM ELEMENT OF A*U .......... */
         i__3 = j;
         for (k = 1; k <= i__3; ++k)
         {
/* L180: */
            g += a[j + k * a_dim1] * a[i__ + k * a_dim1];
         }

         jp1 = j + 1;
         if (l < jp1)
         {
            goto L220;
         }

         i__3 = l;
         for (k = jp1; k <= i__3; ++k)
         {
/* L200: */
            g += a[k + j * a_dim1] * a[i__ + k * a_dim1];
         }
/*     .......... FORM ELEMENT OF P .......... */
       L220:
         e[j] = g / h__;
         f += e[j] * a[i__ + j * a_dim1];
/* L240: */
      }

      h__ = f / (h__ + h__);
/*     .......... FORM REDUCED A .......... */
      i__2 = l;
      for (j = 1; j <= i__2; ++j)
      {
         f = a[i__ + j * a_dim1];
         g = e[j] - h__ * f;
         e[j] = g;

         i__3 = j;
         for (k = 1; k <= i__3; ++k)
         {
            a[j + k * a_dim1] = a[j + k * a_dim1] - f * e[k] - g * a[i__
                                                                     +
                                                                     k *
                                                                     a_dim1];
/* L260: */
         }
      }

    L270:
      i__3 = l;
      for (k = 1; k <= i__3; ++k)
      {
/* L280: */
         a[i__ + k * a_dim1] = scale * a[i__ + k * a_dim1];
      }

    L290:
      h__ = d__[i__];
      d__[i__] = a[i__ + i__ * a_dim1];
      a[i__ + i__ * a_dim1] = h__;
/* L300: */
   }

   return 0;
}                                       /* tred1_ */
