/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
void set_previous_realiz (int intvl, int tposit, double fem_rec_lft,
                          double mal_rec_lft, double prb_Yt_condtl,
                          int **xx0, int **xx1, int nummrks, int nped)
/*    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*    Written:  4th February, 2001                                                                
      Purpose:  initializing data structure for previous state of markov chain 
 */
{
   int   ind;
   int   locus;

/* Set interval in which trait locus lies */
   previous_realiz.intvl = intvl;
/* Set position of trait locus within marker interval */
   previous_realiz.tposit = tposit;
/* Female and male recomb. rates of trait to left marker */
   previous_realiz.rec_lft[0] = fem_rec_lft;
   previous_realiz.rec_lft[1] = mal_rec_lft;
/*  Set P(Y_T | S_intvl, S_{intvl+1}, \lamba_T)   */
   previous_realiz.prb_Yt_condtl = prb_Yt_condtl;
   for (locus = 0; locus <= nummrks; locus++)
      for (ind = 0; ind < nped; ind++)
      {
         previous_realiz.xx0[locus][ind] = xx0[locus][ind];
         previous_realiz.xx1[locus][ind] = xx1[locus][ind];
      }

   return;
}
