/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/******************************************************************************/
/*                                                                            */
/* Traits library.                                             EAT March 02   */
/* routines  set_markdat : moved to Traits library March 02                   */
/* plus new routines:                                                         */
/* The following functions were removed, as no longer compatible              */
/* with parameter statements and output from Pars/ functions:                 */
/*   reset_traitmap  -- resets Loc0 and Rec0   for lm_auto                    */
/*   unset_recval    -- recovers original input recombs and proportions       */
/*   reset_recval    -- resets RecVal and IntVal for lm_lods and other progs  */
/*                                                             MAJ  Feb 04    */
/* Modified to put geno-data into nghds structures             EAT  Sep 04    */
/*   genotypic trait data will now also be set here-- not in set_trait_dat    */
/******************************************************************************/

#include "traits.h"

/**
 * copies marker data to nghd[].g_dat 
 * void set_markdat (int ***yy, int nl, int nc)
 */
void set_markdat (int nl, int nc)
{
   int   i, j, c, cfound;
   int   np, ngobs, *gobs;              /* need to find who has obs genos   EAT 9/04  */
   int  *pdat;                          /* pointer to space block for data: EAT 9/04  */

   gobs = malloc (pedsize * sizeof (int));
   alloc_chk (WHERE, gobs);

/* first we need to know how many have observed marker/trait genotypes */

   for (i = 0; i < pedsize; ++i)
      gobs[i] = 0;
   ngobs = 0;
   np = 0;

/*   There may be individuals in NObs, for which in fact data are 0 */
   for (i = 0; i < NObs; ++i)
   {
      if ((ObsIx[i] = get_posit (ObsNam[i])) == INVALID_INDEX)
         give_warn (ERA_mdp, ObsNam[i]);
      else
      {
         for (j = 0; j < nl; ++j)
         {
            if ((ObsMark[i][j][0] + ObsMark[i][j][1]) > 0)
               break;
         }
         if (j < nl)
         {
            gobs[ObsIx[i]] = 1;
            ++ngobs;
         }
      }
   }

/*   There may be individuals observed for a geno-trait, not in Obs list */
   if (TraitTyp == GENOTYPIC)
      for (i = 0; i < pedsize; ++i)
      {
         if ((data[i][5] > 0) && (gobs[i] == 0))
         {
            gobs[i] = 1;
            ++ngobs;
         }
      }

   for (i = 0; i < NObs; ++i)
   {
      if ((ObsIx[i] = get_posit (ObsNam[i])) == INVALID_INDEX)
         give_warn (ERA_mdp, ObsNam[i]);
      else if (gobs[ObsIx[i]])
      {
         if (np == 0)
         {
            pdat = malloc (ngobs * 2 * (nl + 1) * sizeof (int));
            alloc_chk (WHERE, pdat);
         }
         nghd[ObsIx[i]].g_dat = pdat + 2 * (nl + 1) * np;
         nghd[ObsIx[i]].g_dat[0] = 0;   /* trait geno not yet set */
         nghd[ObsIx[i]].g_dat[1] = 0;
         for (j = 0; j < nl; ++j)
         {
            nghd[ObsIx[i]].g_dat[2 * j + 2] = ObsMark[i][j][0];
            nghd[ObsIx[i]].g_dat[2 * j + 3] = ObsMark[i][j][1];
         }
         ++np;
      }
   }
   if (TraitTyp == GENOTYPIC)
      for (i = 0; i < pedsize; ++i)
      {
         if (data[i][5] > 0)
         {
            if (nghd[i].g_dat == NULL)
            {
               nghd[i].g_dat = pdat + 2 * (nl + 1) * np;
               for (j = -1; j < nl; ++j)
               {
                  nghd[i].g_dat[2 * j + 2] = 0;
                  nghd[i].g_dat[2 * j + 3] = 0;
               }
               ++np;
            }
            if (data[i][5] == 4)        /* homozygous affected */
            {
               nghd[i].g_dat[0] = 2;
               nghd[i].g_dat[1] = 2;
            }
            else if (data[i][5] == 3)   /* recessive carrier  */
            {
               nghd[i].g_dat[0] = 1;
               nghd[i].g_dat[1] = 2;
            }
            else if (data[i][5] == 1)   /*  homozyg normal    */
            {
               nghd[i].g_dat[0] = 1;
               nghd[i].g_dat[1] = 1;
            }
         }
      }

   for (c = 0; c < nc; ++c)
   {
      cfound = 0;
      for (i = 0; i < NObs; ++i)
         if (ObsIx[i] != INVALID_INDEX && (nghd[ObsIx[i]].component) == (c + 1))
            cfound = 1;
      if (!cfound)
         give_warn (ERA_nmd, c + 1);
   }
   return;
}
