/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*  functions are:
 *          allocKey()
 *          storKey()
 *          freeKey()
 */

#include "pedchk.h"

/*----------------------------------------------------------------------*/
/* allocKey:  allocates the list of pointers to the key table,          */
/*            and the key table itself                                  */

void allocKey (void)
{
   KEYS_PP ppK;

   ppKeyTab = (KEYS_PP) malloc (nInd * sizeof (KEYS_PTRS));
   alloc_chk (WHERE, ppKeyTab);

   *ppKeyTab = (KEYS_PTRS) malloc (nInd * sizeof (KEYS));
   alloc_chk (WHERE, *ppKeyTab);
   pFirstKeyTab = *ppKeyTab;

   for (ppK = ppKeyTab; ppK < ppKeyTab + nInd - 1; ++ppK)
      *(ppK + 1) = *ppK + 1;

   return;
}

/*----------------------------------------------------------------------*/
/* storKey:  puts the name and the record index into the key table      */

void storKey (void)
{
   KEYS_PP ppK;
   PED_PTR pP;
   int   i;

   ppK = ppKeyTab;
   pP = pPedDat;

   for (i = 0; i < nInd; ++i)
   {
      strncpy ((*ppK)->nam, pP->nam, MAXNAMLEN + 1);
      (*ppK)->ix = i + 1;
      (*ppK)->ixMa = 0;
      (*ppK)->ixPa = 0;
      (*ppK)->founder = FALSE;
      (*ppK)->chron = 0;
      (*ppK)->comp = 0;

      ++ppK;
      ++pP;
   }
   return;
}

/*----------------------------------------------------------------------*/
/* freeKey:  frees the key table                                        */

void freeKey (void)
{
   if (pFirstKeyTab)
   {
      free (pFirstKeyTab);
      pFirstKeyTab = NULL;
   }
   if (ppKeyTab)
   {
      free (ppKeyTab);
      ppKeyTab = NULL;
   }
   return;
}
