/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#include "stuff.h"

/* functions are:  dub2nlz(),  free_dub()                        */

static int nc = 0;
static char *s = NULL;

char *dub2nlz (double x, int w, int d)
/* 
 *  arguments are:  value to be formatted, print field width,    *
 *                  precision (no. of decimal places)            *
 *  returns :  formatted double with no leading zero             *
 *  requires:  w >= d + 3                                        *
 */
{
   char *t;

   if (w > nc)
   {
      t = realloc (s, (w + 1) * sizeof (char));
      alloc_chk (WHERE, t);
      s = t;
      nc = w;
   }
   if (w < d + 3)
   {
      fprintf (stdout, "\n");
      give_up_where (WHERE, ERS_flz);
   }

   sprintf (s, "%*.*f", w, d, x);

   if (s[w - d - 1] == '.')
      if (x >= 0. && s[w - d - 2] == '0')
         s[w - d - 2] = ' ';
      else if (s[w - d - 2] == '-' && s[w - d - 1] == '0')
      {
         s[w - d - 2] = ' ';
         s[w - d - 1] = '-';
      }

   return s;
}
void free_dub (void)
{
   if (s)
      free (s);
   s = NULL;

   return;
}
